# This is a simple script to compare edge tables to find if a master table has support from a table generated
# with the effects of an organism removed.

# Locaitons of tables of interest:

my $mastertable = "./Correlation_Resubmission_Test/All_EdgeTables/Master_EdgeTable6_clean_stmrsqadj3_Tubonly.txt";
my $PartialAlbugoTable = "./Correlation_Resubmission_Test_PartialAlbugo/All_EdgeTables/Master_EdgeTable6_clean_stmrsqadj3_Tubonly.txt";
my $PartialDioszTable = "./Correlation_Resubmission_Test_PartialDiosz/All_EdgeTables/Master_EdgeTable6_clean_stmrsqadj3_Tubonly.txt";
my $PartialComaTable = "./Correlation_Resubmission_Test_PartialComa/All_EdgeTables/Master_EdgeTable6_clean_stmrsqadj3_Tubonly.txt";
my $PartialMycoTable = "./Correlation_Resubmission_Test_PartialMyco/All_EdgeTables/Master_EdgeTable6_clean_stmrsqadj3_Tubonly.txt";
my $PartialRhizoTable = "./Correlation_Resubmission_Test_PartialRhizo/All_EdgeTables/Master_EdgeTable6_clean_stmrsqadj3_Tubonly.txt";
my $PartialRhodoTable = "./Correlation_Resubmission_Test_PartialRhodo/All_EdgeTables/Master_EdgeTable6_clean_stmrsqadj3_Tubonly.txt";
my $PartialPseudoTable = "./Correlation_Resubmission_Test_PartialPseudo/All_EdgeTables/Master_EdgeTable6_clean_stmrsqadj3_Tubonly.txt";
my $PartialOxaloTable = "./Correlation_Resubmission_Test_PartialOxalo/All_EdgeTables/Master_EdgeTable6_clean_stmrsqadj3_Tubonly.txt";
my $PartialSphingoTable = "./Correlation_Resubmission_Test_PartialSphingo/All_EdgeTables/Master_EdgeTable6_clean_stmrsqadj3_Tubonly.txt";
my $outputfile = "./Correlation_Resubmission_Test/All_EdgeTables/Master_EdgeTable6_clean_stmrsqadj3_Tubonly_PartialSupport.txt";

# First load the Partial correlation edges into hashes

my %PartialAlbugoHash;
my %PartialDioszHash;
my %PartialComaHash;
my %PartialMycoHash;
my %PartialRhizoHash;
my %PartialRhodoHash;
my %PartialPseudoHash;
my %PartialOxaloHash;
my %PartialSphingoHash;

open(ALBUGO, $PartialAlbugoTable);

while(<ALBUGO>){
    
    my $currentline = $_;
    chomp $currentline;
    
    if($currentline =~ /^OrgID/){
        next;
    }
    
    my @splitline = split(/\t/,$currentline);
    
    $PartialAlbugoHash{$splitline[0]}{$splitline[1]} = 1;
    
}

close(ALBUGO);

open(DIOSZ, $PartialDioszTable);

while(<DIOSZ>){
    
    my $currentline = $_;
    chomp $currentline;
    
    if($currentline =~ /^OrgID/){
        next;
    }
    
    my @splitline = split(/\t/,$currentline);
    
    $PartialDioszHash{$splitline[0]}{$splitline[1]} = 1;
    
}

close(DIOSZ);

open(COMA, $PartialComaTable);

while(<COMA>){
    
    my $currentline = $_;
    chomp $currentline;
    
    if($currentline =~ /^OrgID/){
        next;
    }
    
    my @splitline = split(/\t/,$currentline);
    
    $PartialComaHash{$splitline[0]}{$splitline[1]} = 1;
    
}

close(COMA);

open(MYCO, $PartialMycoTable);

while(<MYCO>){
    
    my $currentline = $_;
    chomp $currentline;
    
    if($currentline =~ /^OrgID/){
        next;
    }
    
    my @splitline = split(/\t/,$currentline);
    
    $PartialMycoHash{$splitline[0]}{$splitline[1]} = 1;
    
}

close(MYCO);

open(RHIZO, $PartialRhizoTable);

while(<RHIZO>){
    
    my $currentline = $_;
    chomp $currentline;
    
    if($currentline =~ /^OrgID/){
        next;
    }
    
    my @splitline = split(/\t/,$currentline);
    
    $PartialRhizoHash{$splitline[0]}{$splitline[1]} = 1;
    
}

close(RHIZO);

open(RHODO, $PartialRhodoTable);

while(<RHODO>){
    
    my $currentline = $_;
    chomp $currentline;
    
    if($currentline =~ /^OrgID/){
        next;
    }
    
    my @splitline = split(/\t/,$currentline);
    
    $PartialRhodoHash{$splitline[0]}{$splitline[1]} = 1;
    
}

close(RHODO);

open(PSEUDO, $PartialPseudoTable);

while(<PSEUDO>){
    
    my $currentline = $_;
    chomp $currentline;
    
    if($currentline =~ /^OrgID/){
        next;
    }
    
    my @splitline = split(/\t/,$currentline);
    
    $PartialPseudoHash{$splitline[0]}{$splitline[1]} = 1;
    
}

close(PSEUDO);

open(OXALO, $PartialOxaloTable);

while(<OXALO>){
    
    my $currentline = $_;
    chomp $currentline;
    
    if($currentline =~ /^OrgID/){
        next;
    }
    
    my @splitline = split(/\t/,$currentline);
    
    $PartialOxaloHash{$splitline[0]}{$splitline[1]} = 1;
    
}

close(OXALO);

open(SPHINGO, $PartialSphingoTable);

while(<SPHINGO>){
    
    my $currentline = $_;
    chomp $currentline;
    
    if($currentline =~ /^OrgID/){
        next;
    }
    
    my @splitline = split(/\t/,$currentline);
    
    $PartialSphingoHash{$splitline[0]}{$splitline[1]} = 1;
    
}

close(SPHINGO);

# Now go through the master table, check if the edge has support in either partial, then output the line to a file

open(OUTPUT, ">".$outputfile);
open(MASTER, $mastertable);

my $outheader = "OrgID\tTargetID\tAlbugoPartial\tDioszPartial\tComaPartial\tMycoPartial\tRhizoPartial\tRhodoPartial\tPseudoPartial\tOxaloPartial\tSphingoPartial\n";
print OUTPUT $outheader;

while(<MASTER>){
    
    my $currentline = $_;
    chomp $currentline;
    
    if($currentline =~ /^OrgID/){
        next;
    }
    
    my @splitline = split(/\t/,$currentline);
    
    my $partialAlbSupport;
    my $partialDioszSupport;
    my $partialComaSupport;
    my $partialMycoSupport;
    my $partialRhizoSupport;
    my $partialRhodoSupport;
    my $partialPseudoSupport;
    my $partialOxaloSupport;
    my $partialSphingoSupport;
    
    if($PartialAlbugoHash{$splitline[0]}{$splitline[1]} == 1){
        $partialAlbSupport = "Y";
    }else{$partialAlbSupport = "N";}
    
    if($PartialDioszHash{$splitline[0]}{$splitline[1]} == 1){
        $partialDioszSupport = "Y";
    }else{$partialDioszSupport = "N";}
    
    if($PartialComaHash{$splitline[0]}{$splitline[1]} == 1){
        $partialComaSupport = "Y";
    }else{$partialComaSupport = "N";}
    
    if($PartialMycoHash{$splitline[0]}{$splitline[1]} == 1){
        $partialMycoSupport = "Y";
    }else{$partialMycoSupport = "N";}
    
    if($PartialRhizoHash{$splitline[0]}{$splitline[1]} == 1){
        $partialRhizoSupport = "Y";
    }else{$partialRhizoSupport = "N";}
    
    if($PartialRhodoHash{$splitline[0]}{$splitline[1]} == 1){
        $partialRhodoSupport = "Y";
    }else{$partialRhodoSupport = "N";}
    
    if($PartialPseudoHash{$splitline[0]}{$splitline[1]} == 1){
        $partialPseudoSupport = "Y";
    }else{$partialPseudoSupport = "N";}
    
    if($PartialOxaloHash{$splitline[0]}{$splitline[1]} == 1){
        $partialOxaloSupport = "Y";
    }else{$partialOxaloSupport = "N";}
    
    if($PartialSphingoHash{$splitline[0]}{$splitline[1]} == 1){
        $partialSphingoSupport = "Y";
    }else{$partialSphingoSupport = "N";}
    
    my $outline = $splitline[0]."\t".$splitline[1]."\t".$partialAlbSupport."\t".$partialDioszSupport."\t".$partialComaSupport."\t".$partialMycoSupport."\t".$partialRhizoSupport."\t".$partialRhodoSupport."\t".$partialPseudoSupport."\t".$partialOxaloSupport."\t".$partialSphingoSupport."\n";
    print OUTPUT $outline;
    
}

close OUTPUT;
close MASTER;

exit;